package com.franckbarbier.mediator.java;

public class Main {

    public static void main(String[] args) {
        Communicator callee = new Communicator("callee");
        Communicator caller = new Communicator("caller");

        java.util.EventObject how_are_you_doing_ = new java.util.EventObject(caller) {
            @Override
            public String toString() {
                return "How are you doing?";
            }
        };
        java.util.EventObject fine_and_you_ = new java.util.EventObject(callee) {
            @Override
            public String toString() {
                return "Fine and you?";
            }
        };
        java.util.EventObject not_too_bad_ = new java.util.EventObject(caller) {
            @Override
            public String toString() {
                return "Not too bad...";
            }
        };

        Mediator.Subscribe(callee, how_are_you_doing_);
        Mediator.Subscribe(caller, fine_and_you_);
        Mediator.Subscribe(callee, not_too_bad_);

        Mediator.Occur(how_are_you_doing_);
        Mediator.Occur(fine_and_you_);
        Mediator.Occur(not_too_bad_);
    }
}
